package statemachinetest.ui;

import org.apache.commons.lang.StringUtils;

import statemachinetest.service.StateMachineTestBuilderService;

public class StateMachineTestMaker {

	/**
	 * @param args
	 *            [0]F͂ƂȂastahvWFNgt@C̃pX args[1]:t@Co͂tH_[
	 *            args[2]:ԑJڃpX̒SƂȂԐ(1̏ꍇ͂R̏Ԃɂ܂JڃpX)
	 */
	public static void main(String[] args) {

		try {
			verifyInputArgs(args);
		} catch (Exception e) {
			System.err.println(e.getMessage());
		}
		
		String inputFile = args[0];
		String outputDir = args[1];
		String coverageNumber = "1";
		if(args.length >2 && !StringUtils.isEmpty(args[2])){
			coverageNumber = args[2];
		}

		try {
			StateMachineTestBuilderService builderService = new StateMachineTestBuilderService();
			builderService.export(inputFile, outputDir, coverageNumber);
		
			System.out.println("Success. Data is Exported : " + outputDir);

		} catch (Throwable e) {
			System.out.println("Failed");
			e.printStackTrace();
		}
	}

	protected static void verifyInputArgs(String[] args) throws Exception {
		String errMessage = "Usage: InputAstahFilePath OutputFolderPath)";

		if (args == null || args.length > 3 || args.length < 2) {
			throw new Exception(errMessage);
		}
		if (args.length == 1) {
			if (StringUtils.isEmpty(args[0])) {
				throw new Exception(errMessage);
			}
		}
		if (args.length == 3) {
			args[2] = "1";
//			if (StringUtils.isEmpty(args[2])) {
//				throw new Exception(errMessage);
//			}
//			try {
//				if (Integer.parseInt(args[2]) > 9) {
//					throw new Exception(errMessage);
//				}
//
//			} catch (NumberFormatException e) {
//				throw new Exception(errMessage);
//			}
		}
	}
}
